<div class="row">
  <div class="col-md-12">
    <form [formGroup]="form" *ngIf="form" (ngSubmit)="onSubmit()">

      <div class="row">
        <div class="col-md-6">
          <div class="form-group">
            <label for="name">Card Number</label>
            <input type="text" name="card_number" id="card_number" class="form-control" required
              formControlName="card_number">
            <span class="text-danger"
              *ngIf="form.get('card_number').invalid && (form.get('card_number').dirty || form.get('card_number').touched)">
              <span *ngIf="form.get('card_number').errors.required">
                Card number is required.
              </span>
              <span *ngIf="form.get('card_number').errors.pattern">
                Please enter valid card number.
              </span>
            </span>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-6">
          <div class="form-group">
            <label for="name">Card Holder</label>
            <input type="text" name="card_Holder" id="card_Holder" class="form-control" formControlName="card_Holder">
          </div>
          <span class="text-danger" *ngIf="form.get('card_Holder').invalid && (form.get('card_Holder').dirty ||
            form.get('card_Holder').touched)">
            <span *ngIf="form.get('card_Holder').errors.required">
              Card holder is required.
            </span>
            <span *ngIf="form.get('card_Holder').errors.pattern">
              Please enter valid card holder name.
            </span>
          </span>
        </div>
      </div>
      <div class="row">
        <div class="col-md-6">
          <div class="form-group">
            <label for="name">Expiration Date</label>
            <input type="date" name="expiration_date" id="expiration_date" class="form-control"
              formControlName="expiration_date" required>
          </div>
          <span class="text-danger" *ngIf="form.get('expiration_date').invalid && (form.get('expiration_date').dirty ||
            form.get('expiration_date').touched)">
            <span *ngIf="form.get('expiration_date').errors['nameIsForbidden']">
              Please select valid date.
            </span>
          </span>
        </div>
      </div>
      <div class="row">
        <div class="col-md-6">
          <div class="form-group">
            <label for="name">Security Code</label>
            <input type="text" name="security_code" id="security_code" class="form-control"
              formControlName="security_code">
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-6">
          <div class="form-group">
            <label for="name">Amount</label>
            <input type="number" name="amount" id="amount" class="form-control" formControlName="amount">
          </div>
        </div>
      </div>

      <button class="btn btn-primary" [disabled]="!form.valid">submit</button>
    </form>
  </div>
</div>
